SELECT 
"Date",
toYear("Date") as "Year",
toQuarter("Date") as "QuarterNumber",
concat(toString(toQuarter("Date")), '/Q') as "Quarter",
toYear("Date")*10 + toQuarter("Date") AS "YearQuarterNumber",
concat(toString(toYear("Date")), '-Q', toString(toQuarter("Date")) ) as "YearQuarter",
toMonth("Date") as "MonthNumber",
"MonthName",
"MonthShortName",
toYear("Date") * 100 + toMonth("Date") AS "YearMonthNumber",
concat(toString(toYear("Date")), '-', toString("MonthShortNameLowerCase")) AS "YearMonth",
concat("MonthShortNameLowerCase", ' ', toString(toYear("Date"))) AS "MonthYear",
toISOWeek("Date") as "WeekNumber",
toYearWeek("Date", 3) as "YearWeek",
toStartOfWeek("Date", 3) as "StartOfWeek",
date_add(DAY, 6, toStartOfWeek("Date", 3)) as "LastDayOfWeek",
toDayOfWeek("Date") as "DayOfWeek",
"DayOfWeekName",
toDayOfMonth("Date") as "DayOfMonth",
toDayOfYear("Date") as "DayOfYear",
toStartOfYear("Date") as "StartOfYear",
date_add(DAY, -1, date_add(YEAR, 1, toStartOfYear("Date"))) as "EndOfYear",
toStartOfQuarter("Date") AS "StartOfQuarter",
date_add(DAY, -1, date_add(QUARTER, 1, toStartOfQuarter("Date"))) as "EndOfQuarter",
toStartOfMonth("Date") AS "StartOfMonth",
toLastDayOfMonth("Date") AS "EndOfMonth",
concat(splitByChar('-', toString("Date"))[3], '.', splitByChar('-', toString("Date"))[2]) AS "DayMonth",
concat(
    concat(
        splitByChar('-', toString(toStartOfWeek("Date", 3)))[3], 
        '.', 
        splitByChar('-', toString(toStartOfWeek("Date", 3)))[2]
    ), 
    '-', 
    concat(
        splitByChar('-', toString(date_add(DAY, 6, toStartOfWeek("Date", 3))))[3], 
        '.', 
        splitByChar('-', toString(date_add(DAY, 6, toStartOfWeek("Date", 3))))[2]
    )
) AS "WeekPeriod",
CASE 
    WHEN "Date" = toDate(now()) THEN 'Сегодня' ELSE toString("Date")
END AS "CurrentDate",
CASE 
    WHEN toMonth("Date") = toMonth(toDate(now())) THEN 'Текущий месяц' ELSE "MonthShortName"
END AS "CurrentMonth",
CASE 
    WHEN toQuarter("Date") = toQuarter(toDate(now())) THEN 'Текущий квартал' ELSE toString(toQuarter("Date"))
END AS "CurrentQuarter",
CASE 
    WHEN toYear("Date") = toYear(toDate(now())) THEN 'Текущий год' ELSE toString(toYear("Date"))
END AS "CurrentYear"
FROM
(
    -- DISTINCT нужен, так как arrayJoin может вернуть дублирующиеся значения.
	SELECT DISTINCT
	arrayJoin(arrayMap(x -> toDate(x), range(toUInt32(toStartOfDay(toDate(<startDate>))), toUInt32(toStartOfDay(date_add(DAY, 1, toDate(<endDate>)))), 86400))) as "Date",
	CASE 
	    WHEN toMonth("Date") = 1 THEN 'Январь'
	    WHEN toMonth("Date") = 2 THEN 'Февраль'
	    WHEN toMonth("Date") = 3 THEN 'Март'
	    WHEN toMonth("Date") = 4 THEN 'Апрель'
	    WHEN toMonth("Date") = 5 THEN 'Май'
	    WHEN toMonth("Date") = 6 THEN 'Июнь'
	    WHEN toMonth("Date") = 7 THEN 'Июль'
	    WHEN toMonth("Date") = 8 THEN 'Август'
	    WHEN toMonth("Date") = 9 THEN 'Сентябрь'
	    WHEN toMonth("Date") = 10 THEN 'Октябрь'
	    WHEN toMonth("Date") = 11 THEN 'Ноябрь'
	    WHEN toMonth("Date") = 12 THEN 'Декабрь'
	END AS "MonthName",
	CASE 
	    WHEN toMonth("Date") = 1 THEN 'Янв'
	    WHEN toMonth("Date") = 2 THEN 'Фев'
	    WHEN toMonth("Date") = 3 THEN 'Мар'
	    WHEN toMonth("Date") = 4 THEN 'Апр'
	    WHEN toMonth("Date") = 5 THEN 'Май'
	    WHEN toMonth("Date") = 6 THEN 'Июн'
	    WHEN toMonth("Date") = 7 THEN 'Июл'
	    WHEN toMonth("Date") = 8 THEN 'Авг'
	    WHEN toMonth("Date") = 9 THEN 'Сен'
	    WHEN toMonth("Date") = 10 THEN 'Окт'
	    WHEN toMonth("Date") = 11 THEN 'Ноя'
	    WHEN toMonth("Date") = 12 THEN 'Дек'
	END AS "MonthShortName",
	CASE 
	    WHEN toMonth("Date") = 1 THEN 'янв'
	    WHEN toMonth("Date") = 2 THEN 'фев'
	    WHEN toMonth("Date") = 3 THEN 'мар'
	    WHEN toMonth("Date") = 4 THEN 'апр'
	    WHEN toMonth("Date") = 5 THEN 'май'
	    WHEN toMonth("Date") = 6 THEN 'июн'
	    WHEN toMonth("Date") = 7 THEN 'июл'
	    WHEN toMonth("Date") = 8 THEN 'авг'
	    WHEN toMonth("Date") = 9 THEN 'сен'
	    WHEN toMonth("Date") = 10 THEN 'окт'
	    WHEN toMonth("Date") = 11 THEN 'ноя'
	    WHEN toMonth("Date") = 12 THEN 'дек'
	END AS "MonthShortNameLowerCase",
	CASE
	    WHEN toDayOfWeek("Date") = 1 THEN 'Пн'
	    WHEN toDayOfWeek("Date") = 2 THEN 'Вт'
	    WHEN toDayOfWeek("Date") = 3 THEN 'Ср'
	    WHEN toDayOfWeek("Date") = 4 THEN 'Чт'
	    WHEN toDayOfWeek("Date") = 5 THEN 'Пт'
	    WHEN toDayOfWeek("Date") = 6 THEN 'Сб'
	    WHEN toDayOfWeek("Date") = 7 THEN 'Вс'
	END AS "DayOfWeekName"
) AS "Calendar"